#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> g;
vector<bool> vis, done;

vector<int> topo;
bool dfs(int x) {
    vis[x] = true;
    bool res = true;
    for(int y : g[x]){
        if(!vis[y]) {
            res = dfs(y) && res;
        } else if(!done[y]) {
            res = false;
        }
    }
    done[x] = true;
    topo.push_back(x);
    return res;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin>>n>>m;

    vis.resize(n);
    done.resize(n);
    g.resize(n);

    for(int i = 0; i < m; i++){
        int a, b;
        cin>>a>>b;
        --a, --b,
        g[a].push_back(b);
    }

    bool ok = true;
    for(int i = 0; i < n; i++) if(!vis[i]) ok = ok && dfs(i);

    if(!ok){
        cout << "NO\n";
        return 0;
    }

    reverse(topo.begin(), topo.end());
    for(int x : topo) cout << x + 1 << '\n';

    return 0;
}